class DHUD expands UnrealHUD;

/* A message on the HUD */
struct DMessage
{
var bool bAlive;
var playerreplicationinfo PRI;
var string Msg;
var name N;
var float RecvTime;
var class<DXMessage> XMessageClass;
var object O1, O2, O3;
var int Sw;
};

var DMessage Msgs[100];
var DPRI ArPri[64];
var RadPoint ArRad[64];
var int PriCount;
var font WhiteFont;
var bool bBlink;
var float FaceOff;
var float LastFaceTime;
var texture LastFace;
var class<DFace> LastDFace;

var WeapMeshAct WMA;

var float HalfHudFlash[11];
var float HalfHudOffs[11];
var int CurHHItem;
var float CurHHTakeout;

var config bool bDontDrawWeaponIcon;

const hDefBarSize = 20;                 // Animated horizontal bar size.
const alertAnimTime = 0.5;              // Animation cycle time.
const alertAnimDist = 64;               // Distance the animated bar moves away from the window.
const alertBorderSize = 32;             // Distance between borders and text of the window.
const newLineToken = "\\n";             // Token used to break the text in multiple lines.

const animCycleTime = 0.5;             // Progress indicator animation cycle time.

var float TimeSeconds;
var float ReadySeconds;

var float AltScale;

static final operator(16) color * ( color A, float B )
{
local color C;
C.R=A.R*B;
C.G=A.G*B;
C.B=A.B*B;
return C;
}

function DrawBar(Canvas C, optional float SmoothDelta)
{
	local float BaseX,BaseY;
	local float animIndex;
	local int position;
	local int nextPosition;
	local int i;
	local float phase;
	local color segmentColor;
	local float Coef;
	if (DPlayer(Owner)==None) return;
	if (DPlayer(Owner).myPRI==None) return;
	//if ((ReadySeconds>5) && (SmoothDelta==0) && (int(Smerp(Coef,C.ClipX/2-128,C.ClipX)-SmoothDelta*4)>C.ClipX)) return;
	if (ReadySeconds>5) return;
	if (ReadySeconds<4) Coef=0;
	else
	Coef=(ReadySeconds-4);
	C.DrawColor=GetC(255,255,255)*(1-SmoothDelta);
	C.Style=3;
	C.SetPos(int(Smerp(Coef,C.ClipX/2-128,C.ClipX)-SmoothDelta*4),int(C.ClipY/4*3));
	if (DPlayer(Owner).myPRI.AckLevel<5)
	{ C.DrawIcon(texture'LoadingBar',1); SegmentColor=GetC(0,0,255)*(1-SmoothDelta); }
	else
	{ C.DrawIcon(texture'ReadyBar',1); SegmentColor=GetC(0,255,0)*(1-SmoothDelta); }

	animIndex = (timeSeconds % animCycleTime) / animCycleTime;
	nextPosition = int(animIndex * 14);
	phase = (animIndex * 14) % 1.0;
	for (i = 0; i <= 5; i++)
	{
		position = nextPosition - i;
		if (position < 0) position += 13;

		if (i == 0)
			c.drawColor = segmentColor * phase;
		else
			c.drawColor = segmentColor * fClamp(((5 - i + 1) / 5) - phase / 5, 0.0, 1.0);
		c.setPos(int(Smerp(Coef,C.ClipX/2-128,C.ClipX) + 69 + position * 14 - SmoothDelta*4 ), int(C.ClipY/4*3));
		c.drawTile(Texture'barsegment', 16, 16, 0.0, 0.0, 16, 16);
	}
}

function DrawAlert(Canvas c, string msg, color textColor, color baseColor)
{
	local int windowWidth;
	local int windowHeight;
	local int cx, cy;
	local float animIndex;
	local int dist;
	local int hBarSize;
	local float textWidth;
	local int maxTextWidth;
	local float textHeight;
	local int lineCount;
	local string remaining;
	local int index;
	local string text;

	// Initialize.
	c.font = font'UTLadder24';
	remaining = msg;
	lineCount = 0;
	while (remaining != "") {
		index = instr(remaining, newLineToken);
		if (index > 0) {
			text = left(remaining, index);
			remaining = mid(remaining, index + len(newLineToken));
		} else {
			text = remaining;
			remaining = "";
		}
		c.strLen(text, textWidth, textHeight);
		maxTextWidth = max(maxTextWidth, textWidth);
		lineCount++;
	}

	windowWidth = maxTextWidth + 2 * alertBorderSize;
	windowHeight = lineCount * textHeight + 2 * alertBorderSize;
	cx = (c.clipX - windowWidth) / 2;
	cy = (c.clipY - windowHeight) / 2;

	// Render frame background.
	c.style = ERenderStyle.STY_Translucent;
	c.drawColor = baseColor * 0.4;
	c.setPos(cx, cy);
	c.drawTile(Texture'grad64', windowWidth, windowHeight, 0.0, 0.0, 64.0, 64.0);

	// Render borders.
	c.drawColor = baseColor * 0.8;
	c.setPos(cx - 3.0, cy - 1.0);
	c.drawTile(Texture'base', 2.0, windowHeight + 2.0, 0.0, 0.0, 1.0, 1.0);
	c.setPos(cx + 1.0 + windowWidth, cy - 1.0);
	c.drawTile(Texture'base', 2.0, windowHeight + 2.0, 0.0, 0.0, 1.0, 1.0);
	c.setPos(cx - 3.0, cy - 2.0);
	c.drawTile(Texture'base', hDefBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);
	c.setPos(cx - 3.0, cy + 1.0 + windowHeight);
	c.drawTile(Texture'base', hDefBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);
	c.setPos(cx + 3.0 + windowWidth - hDefBarSize, cy - 2.0);
	c.drawTile(Texture'base', hDefBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);
	c.setPos(cx + 3.0 + windowWidth - hDefBarSize, cy + 1.0 + windowHeight);
	c.drawTile(Texture'base', hDefBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);

	// High detail animation effect.
	//if (level.bHighDetailMode)
	//{
		animIndex = (timeSeconds % alertAnimTime) / alertAnimTime;

		c.drawColor = baseColor * (1.0 - animIndex);

		dist = sin(animIndex * pi * 0.5) * alertAnimDist;
		hBarSize = hDefBarSize + hDefBarSize * ((windowWidth + alertAnimDist) / windowWidth) * animIndex;
		c.setPos(cx - 3.0 - dist, cy - 1.0 - dist);
		c.drawTile(Texture'base', 2.0, windowHeight + 2.0 + 2 * dist, 0.0, 0.0, 1.0, 1.0);
		c.setPos(cx + 1.0 + windowWidth + dist, cy - 1.0 - dist);
		c.drawTile(Texture'base', 2.0, windowHeight + 2.0 + 2 * dist, 0.0, 0.0, 1.0, 1.0);
		c.setPos(cx - 3.0 - dist, cy - 2.0 - dist);
		c.drawTile(Texture'base', hBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);
		c.setPos(cx - 3.0 - dist, cy + 1.0 + windowHeight + dist);
		c.drawTile(Texture'base', hBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);
		c.setPos(cx + 3.0 + windowWidth - hBarSize + dist, cy - 2.0 - dist);
		c.drawTile(Texture'base', hBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);
		c.setPos(cx + 3.0 + windowWidth - hBarSize + dist, cy + 1.0 + windowHeight + dist);
		c.drawTile(Texture'base', hBarSize, 1.0, 0.0, 0.0, 1.0, 1.0);
	//}

	// Render text.
	remaining = msg;
	lineCount = 0;
	c.drawColor = textColor;
	while (remaining != "") {
		index = instr(remaining, newLineToken);
		if (index > 0) {
			text = left(remaining, index);
			remaining = mid(remaining, index + len(newLineToken));
		} else {
			text = remaining;
			remaining = "";
		}
		c.setPos(cx + alertBorderSize, cy + alertBorderSize + lineCount * textHeight);
		c.drawText(text, false);
		lineCount++;
	}
}

function DrawHHBase(canvas C, optional bool bPost)
{
	local int I;
	local int S;
	local float Offs;
	S=C.Style;
	C.DrawColor=GetC(127,127,127);
	for (I=1;I<11;I++)
	{
	if (!bPost)
		{
		if (CurHHItem==I) Offs=int(CurHHTakeOut*60)+30; else Offs=30;
		HalfHudOffs[I]=Offs;
		C.SetPos(C.ClipX-Offs,C.ClipY-400+I*23);
		C.Style=2;
		C.DrawTile(texture'U2HalfHud',Offs,21,0,30,Offs,21);
		}
	if (bPost)
		{
		Offs=HalfHudOffs[I];
		if (HalfHudFlash[I]>0)
			{
			C.Style=3;
			C.DrawColor=GetC(255*HalfHudFlash[I],255*HalfHudFlash[I],0);
			C.SetPos(C.ClipX-Offs,C.ClipY-400+I*23);
			C.DrawTile(texture'U2HalfHud',FMin(30,Offs),21,101,0,FMin(30,Offs),21);
			if (Offs>30)
				{
				C.SetPos(C.ClipX-Offs+30,C.ClipY-400+I*23);
				C.DrawTile(texture'U2HalfHud',Offs-30,21,132,0,27,21);
				}
			}
		}
	C.DrawColor=GetC(127,127,127);
	}
	C.Style=S;
}

exec function DDWI()
{
bDontDrawWeaponIcon=!bDontDrawWeaponIcon;
SaveConfig();
}

event Tick ( float DeltaTime )
{
	local int I;

	TimeSeconds+=DeltaTime/Level.TimeDilation;

	IdentifyFadeTime -= DeltaTime;
	if (IdentifyFadeTime < 0.0)
		IdentifyFadeTime = 0.0;

	MOTDFadeOutTime -= DeltaTime * 10 * DPlayer(Owner).MOTDFadeOut;
	if (MOTDFadeOutTime < 0.0)
		MOTDFadeOutTime = 0.0;

	/* Clear deprecated messages */
	CheckMessages();

	if (CurHHTakeout<1)
		CurHHTakeout+=(DeltaTime*2);
	else
		CurHHTakeout=1;
	for (I=0;I<11;I++)
		if (HalfHudFlash[I]>0)
			HalfHudFlash[I]-=DeltaTime;
		else
			HalfHudFlash[I]=0;

	if (DPlayer(Owner)==None) return;
	if (DPlayer(Owner).myPRI==None) return;

	if (DPlayer(Owner).myPRI.AckLevel>4)
		ReadySeconds+=DeltaTime/Level.TimeDilation;
}

function PreRender( canvas Canvas )
{
	local float Sp2d;
	local vector Vel;
	super.PreRender(Canvas);
	Vel=Pawn(Owner).Velocity;
	Sp2d=VSize(Vel);
//	if (Sp2d>700)
//	PlayerPawn(Owner).DesiredFov=FClamp(Lerp((Sp2d-700)/800,90,140),90,140);
//	if (Sp2d<700)
//	if (PlayerPawn(Owner).DesiredFov>90)
//	PlayerPawn(Owner).DesiredFov=90;
}

function DrawCrossHair( canvas C, int SX, int SY )
{
	if (Crosshair>5) Return;
	C.SetPos(SX,SY);
	C.Style=3;
	/*if		(Crosshair==0) 	C.DrawIcon(Texture'Crosshair1', 1.0);
	else if (Crosshair==1) 	C.DrawIcon(Texture'Crosshair2', 1.0);
	else if (Crosshair==2) 	C.DrawIcon(Texture'Crosshair3', 1.0);
	else if (Crosshair==3) 	C.DrawIcon(Texture'Crosshair4', 1.0);
	else if (Crosshair==4) 	C.DrawIcon(Texture'Crosshair5', 1.0);
	else if (Crosshair==5) 	C.DrawIcon(Texture'Crosshair7', 1.0);*/
	switch (Crosshair)
	{
	case 0:
	C.DrawColor=GetC(0,255,0);
	C.SetPos(SX-1,SY-1);
	C.DrawTile(texture'Base',1,1,0,0,1,1);
	C.SetPos(SX-1,SY-24-5);
	C.DrawTile(texture'GradU',1,24,0,0,1,256);
	C.SetPos(SX-1,SY+5);
	C.DrawTile(texture'GradD',1,24,0,0,1,256);
	C.SetPos(SX-24-5,SY-1);
	C.DrawTile(texture'GradL',24,1,0,0,256,1);
	C.SetPos(SX+5,SY-1);
	C.DrawTile(texture'GradR',24,1,0,0,256,1);
	break;
	case 1:
	C.DrawColor=GetC(0,255,0);
	C.SetPos(SX-1,SY-1);
	C.DrawTile(texture'Base',1,1,0,0,1,1);
	C.SetPos(SX-1,SY-16);
	C.DrawTile(texture'GradU',1,16,0,0,1,256);
	C.SetPos(SX-1,SY);
	C.DrawTile(texture'GradD',1,16,0,0,1,256);
	C.SetPos(SX-16,SY-1);
	C.DrawTile(texture'GradL',16,1,0,0,256,1);
	C.SetPos(SX,SY-1);
	C.DrawTile(texture'GradR',16,1,0,0,256,1);
	break;
	case 2:
	C.DrawColor=GetC(0,255,0);
	C.SetPos(SX-1,SY-1);
	C.DrawTile(texture'Base',1,1,0,0,1,1);
	break;
	case 3:
	C.DrawColor=GetC(0,255,0);
	C.SetPos(SX-1,SY-1);
	C.DrawTile(texture'Base',1,1,0,0,1,1);
	C.SetPos(SX-1,SY);
	C.DrawTile(texture'GradD',1,16,0,0,1,256);
	C.SetPos(SX,SY-1);
	C.DrawTile(texture'GradR',16,1,0,0,256,1);
	break;
	case 4:
	C.DrawColor=GetC(255,0,0);
	C.SetPos(SX-1,SY-1);
	C.DrawTile(texture'Base',1,1,0,0,1,1);
	C.SetPos(SX-1,SY-16);
	C.DrawTile(texture'GradU',1,16,0,0,1,256);
	C.SetPos(SX-1,SY);
	C.DrawTile(texture'GradD',1,16,0,0,1,256);
	C.SetPos(SX-16,SY-1);
	C.DrawTile(texture'GradL',16,1,0,0,256,1);
	C.SetPos(SX,SY-1);
	C.DrawTile(texture'GradR',16,1,0,0,256,1);
	break;
	case 5:
	C.DrawColor=GetC(255,0,0);
	C.SetPos(SX-1,SY-1);
	C.DrawTile(texture'Base',1,1,0,0,1,1);
	C.SetPos(SX-1,SY);
	C.DrawTile(texture'GradD',1,16,0,0,1,256);
	C.SetPos(SX,SY-1);
	C.DrawTile(texture'GradR',16,1,0,0,256,1);
	break;
	}
	C.Style = 1;
	C.DrawColor=GetC(127,127,127);
}

function PostRender( canvas Canvas )
{
	local float F;
	DrawBar(Canvas);
	if (ReadySeconds>4)
	DrawBar(Canvas,0.5);
	HUDSetup(canvas);
	bBlink=!bBlink;

	if ( PlayerPawn(Owner) != None )
	{
	if (DPlayer(Owner)!=None)
	if (DPlayer(Owner).myPRI!=None)
	{
	if (ReadySeconds==0)
	DrawAlert(Canvas,"DCoop v"$Class'DUtil'.Static.Ver()$"\\nLoading: "$(DPlayer(Owner).myPRI.AckLevel*20)$"%",GetC(128,128,255)*FClamp(5-ReadySeconds,0,1),GetC(0,0,255)*FClamp(5-ReadySeconds,0,1));
	else if (ReadySeconds<5)
	DrawAlert(Canvas,"DCoop v"$Class'DUtil'.Static.Ver()$"\\nReady: 100%",GetC(128,255,128)*FClamp(5-ReadySeconds,0,1),GetC(0,255,0)*FClamp(5-ReadySeconds,0,1));
	}
		if ( PlayerPawn(Owner).PlayerReplicationInfo == None )
			return;
		if ( PlayerPawn(Owner).bShowMenu )
		{
			DisplayMenu(Canvas);
			return;
		}
		if ( PlayerPawn(Owner).bShowScores )
		{
			if ( ( PlayerPawn(Owner).Weapon != None ) && ( !PlayerPawn(Owner).Weapon.bOwnsCrossHair ) )
				DrawCrossHair(Canvas, 0.5 * Canvas.ClipX, 0.5 * Canvas.ClipY);
			if ( (PlayerPawn(Owner).Scoring == None) && (PlayerPawn(Owner).ScoringType != None) )
				PlayerPawn(Owner).Scoring = Spawn(PlayerPawn(Owner).ScoringType, PlayerPawn(Owner));
			if ( PlayerPawn(Owner).Scoring != None )
			{
				PlayerPawn(Owner).Scoring.ShowScores(Canvas);
				return;
			}
		}
		else if ( (PlayerPawn(Owner).Weapon != None) && (Level.LevelAction == LEVACT_None) )
		{
			Canvas.Font = WhiteFont;
			PlayerPawn(Owner).Weapon.PostRender(Canvas);
			if ( !PlayerPawn(Owner).Weapon.bOwnsCrossHair )
				DrawCrossHair(Canvas, 0.5 * Canvas.ClipX, 0.5 * Canvas.ClipY);
		}

		if ( PlayerPawn(Owner).ProgressTimeOut > Level.TimeSeconds )
			DisplayProgressMessage(Canvas);

	}

	if (HudMode==5)
	{
		DrawInventory(Canvas, Canvas.ClipX-96,0,False);
		Return;
	}
	if (Canvas.ClipX<320) HudMode = 4;

	if (HudMode==0)
		DrawU2Hud(Canvas);
	else
	{
	Canvas.Font=WhiteFont;
	Canvas.DrawColor=GetC(0,64,255);
	Canvas.SetPos(4,128+16+8);
	Canvas.DrawText("SC: "$int(DPlayer(Owner).myPRI.Score));
	Canvas.SetPos(4,128+16*2+8);
	Canvas.DrawText("DP: "$DPlayer(Owner).myPRI.DmgPts);
	Canvas.DrawColor=GetC(255,255,255);

	Canvas.Style=1;

	// Draw Armor
	if (HudMode<4) DrawArmor(Canvas, 0, Canvas.ClipY-64,False);
//	else if (HudMode==3 || HudMode==2) DrawArmor(Canvas, 0, Canvas.ClipY-32,False);
	else if (HudMode==4) DrawArmor(Canvas, Canvas.ClipX-64, Canvas.ClipY-64,True);

	// Draw Ammo
	if (HudMode!=4) DrawAmmo(Canvas, Canvas.ClipX-48-64, Canvas.ClipY-32);
	else DrawAmmo(Canvas, Canvas.ClipX-48, Canvas.ClipY-32);

	// Draw Health
	if (HudMode<4) DrawHealth(Canvas, 0, Canvas.ClipY-32);
//	else if (HudMode==3||HudMode==2) DrawHealth(Canvas, Canvas.ClipX-128, Canvas.ClipY-32);
	else if (HudMode==4) DrawHealth(Canvas, Canvas.ClipX-64, Canvas.ClipY-32);

	// Display Inventory
	if (HudMode<2) DrawInventory(Canvas, Canvas.ClipX-96, 0,False);
	else if (HudMode==3) DrawInventory(Canvas, Canvas.ClipX-96, Canvas.ClipY-64,False);
	else if (HudMode==4) DrawInventory(Canvas, Canvas.ClipX-64, Canvas.ClipY-64,True);
	else if (HudMode==2) DrawInventory(Canvas, Canvas.ClipX/2-64, Canvas.ClipY-32,False);

	// Display Frag count
//	if ( (Level.Game == None) || Level.Game.bDeathMatch )
//	{
		if (HudMode<4) DrawFragCount(Canvas, Canvas.ClipX-32,Canvas.ClipY-64);
//		else if (HudMode==3) DrawFragCount(Canvas, 0,Canvas.ClipY-64);
		else if (HudMode==4) DrawFragCount(Canvas, 0,Canvas.ClipY-32);
//	}
	}

	// Display Identification Info
	DrawIdentifyInfo(Canvas, 0, Canvas.ClipY - 64.0);

	// Message of the Day / Map Info Header
	if (MOTDFadeOutTime != 0.0)
		DrawMOTD(Canvas);

	// Team Game Synopsis
	if ( (PlayerPawn(Owner).GameReplicationInfo != None) && PlayerPawn(Owner).GameReplicationInfo.bTeamGame)
		DrawTeamGameSynopsis(Canvas);
	if ( (PlayerPawn(Owner).GameReplicationInfo != None) && (PlayerPawn(Owner).GameReplicationInfo.IsA('DGRI')) )
		DrawAltMeter(Canvas);
	if ( Owner.IsA('DPlayer') )
		DrawMail(Canvas);
	DrawRad(Canvas);
}

function DrawRad(canvas Canvas)
{
	local vector RadToPl;
	local float Angle,X,Y,XL,YL,NA,SA;
	local rotator RotRadToPl, MyRot;
	local RadPoint RP;
	local int I,D;

	Canvas.Font=Canvas.SmallFont;

	Canvas.DrawColor=GetC(0,255,0);
	Canvas.Style=3;

	Canvas.SetPos(75-1,Canvas.ClipY-190-3);
	Canvas.DrawTile(texture'GradU',1,5,0,0,1,256);
	Canvas.SetPos(75-3,Canvas.ClipY-190-1);
	Canvas.DrawTile(texture'Base',5,1,0,0,1,1);

	//North
	RadToPl = vect(1,0,0);
	RotRadToPl = Rotator(RadToPl);
	MyRot = Rotator(Vector(Owner.Rotation));
	if ( MyRot.Yaw < 0 )
	MyRot.Yaw += 65535;
	if ( RotRadToPl.Yaw < 0 )
	RotRadToPl.Yaw += 65535;
	Angle = MyRot.Yaw - RotRadToPl.Yaw;
	if (Angle>65535) Angle-=65535;
	NA=Angle/65535*360;
	X = ( -Sin( (Angle/65535)*2*Pi ) );
	Y = ( Cos( (Angle/65535)*2*Pi ) );
	Canvas.DrawColor=GetC(0,0,255);
	Canvas.StrLen("N",XL,YL);
	Canvas.SetPos(75+X*40-1-XL/2,Canvas.ClipY-190-Y*40-1-YL/2);
	Canvas.DrawText("N");
	//for (D=0;D<50;D++)
	//{
	//Canvas.SetPos(75+X*D-1,Canvas.ClipY-190-Y*D-1);
	//Canvas.DrawTile(texture'Base',1,1,0,0,1,1);
	//}
	//South
	RadToPl = vect(-1,0,0);
	RotRadToPl = Rotator(RadToPl);
	MyRot = Rotator(Vector(Owner.Rotation));
	if ( MyRot.Yaw < 0 )
	MyRot.Yaw += 65535;
	if ( RotRadToPl.Yaw < 0 )
	RotRadToPl.Yaw += 65535;
	Angle = MyRot.Yaw - RotRadToPl.Yaw;
	if (Angle>65535) Angle-=65535;
	SA=Angle/65535*360;
	X = ( -Sin( (Angle/65535)*2*Pi ) );
	Y = ( Cos( (Angle/65535)*2*Pi ) );
	Canvas.DrawColor=GetC(255,0,0);
	Canvas.StrLen("S",XL,YL);
	Canvas.SetPos(75+X*40-1-XL/2,Canvas.ClipY-190-Y*40-1-YL/2);
	Canvas.DrawText("S");
	//for (D=0;D<50;D++)
	//{
	//Canvas.SetPos(75+X*D-1,Canvas.ClipY-190-Y*D-1);
	//Canvas.DrawTile(texture'Base',1,1,0,0,1,1);
	//}

	for (I=0;I<64;I++)
	if (ArRad[I]!=None)
	{
	RP=ArRad[I];
	if (!RP.bRadHidden)
	{
	Canvas.DrawColor=RP.RadColor;
	RadToPl = RP.Location - Owner.Location;
	RadToPl.Z = 0;
	RotRadToPl = Rotator(RadToPl);
	MyRot = Rotator(Vector(Owner.Rotation));
	if ( MyRot.Yaw < 0 )
	MyRot.Yaw += 65535;
	if ( RotRadToPl.Yaw < 0 )
	RotRadToPl.Yaw += 65535;
	Angle = MyRot.Yaw - RotRadToPl.Yaw;
	if (Angle < 0) Angle+=65535;
	X = ( -Sin( (Angle/65535)*2*Pi ) );
	Y = ( Cos( (Angle/65535)*2*Pi ) );
	for (D=0;D<50;D++)
	{
	Canvas.SetPos(75+X*D-1,Canvas.ClipY-190-Y*D-1);
	Canvas.DrawTile(texture'Base',1,1,0,0,1,1);
	}
	}
	}
	Canvas.DrawColor=GetC(0,255,0);
	for (I=0;I<360;I++)
	{
	if ((Abs(Float(I)-NA)<8)||(Abs(Float(I-360)-(NA))<8))
		Canvas.DrawColor=GetC(0,0,255);
	else if ((Abs(Float(I)-SA)<8)||(Abs(Float(I-360)-(SA))<8))
		Canvas.DrawColor=GetC(255,0,0);
	else if (I<45)
		Canvas.DrawColor=GetC(255*float(45-I),255,0);
	else if (I>315)
		Canvas.DrawColor=GetC(255,255,0);
	else
		Canvas.DrawColor=GetC(0,255,0);
	X = ( -Sin( float(I)*2*Pi/360 ) );
	Y = ( Cos( float(I)*2*Pi/360 ) );
	Canvas.SetPos(75+X*50-1,Canvas.ClipY-190-Y*50-1);
	Canvas.DrawTile(texture'Base',1,1,0,0,1,1);
	}
}

function DrawMail(canvas Canvas)
{
	local float XL, YL;
	if (DPlayer(Owner).myPRI.MsgCnt>0)
	{
	Canvas.DrawColor=GetC(64,64,64);
	Canvas.Style=3;
	Canvas.SetPos(75-32,Canvas.ClipY-400-32);
	Canvas.DrawIcon(texture'Mail',0.5);
	Canvas.Font=Font'TahomaB10';
	Canvas.StrLen(DPlayer(Owner).myPRI.MsgCnt,XL,YL);
	Canvas.DrawColor=GetC(255,255,255);
	Canvas.Style=4;
	Canvas.SetPos(75-XL/2, Canvas.ClipY-400-YL/2);
	Canvas.DrawText(DPlayer(Owner).myPRI.MsgCnt);
	}
}

function DrawAltMeter(canvas Canvas)
{
	local DGRI GRI;
	local float LocDelta,YL;
	GRI=DGRI(PlayerPawn(Owner).GameReplicationInfo);
	if (GRI.LowKillZ>=GRI.HiKillZ) return;
	Canvas.Style=3;
	Canvas.DrawColor=GetC(127,127,0);
	Canvas.Font=Canvas.SmallFont;
	Canvas.StrLen("1234567890",LocDelta,YL);
	Canvas.SetPos(49,Canvas.ClipY-351);
	Canvas.DrawTile(texture'SoftGradL',52,1,0,0,256,1);
	Canvas.SetPos(49,Canvas.ClipY-351);
	Canvas.DrawTile(texture'SoftGradU',1,102,0,0,1,256);
	Canvas.SetPos(49,Canvas.ClipY-249);
	Canvas.DrawTile(texture'SoftGradR',52,1,0,0,256,1);
	Canvas.SetPos(100,Canvas.ClipY-351);
	Canvas.DrawTile(texture'SoftGradD',1,102,0,0,1,256);
	if (AltScale==0)
	{
	Canvas.DrawColor=GetC(0,100,255);
	Canvas.SetPos(105,Canvas.ClipY-350-YL/2);
	Canvas.DrawText(int(GRI.HiKillZ));
	Canvas.SetPos(50,Canvas.ClipY-350);
	Canvas.DrawTile(texture'GradL',25,2,0,0,255,0);
	Canvas.SetPos(75,Canvas.ClipY-350);
	Canvas.DrawTile(texture'GradR',25,2,0,0,255,0);
	Canvas.DrawColor=GetC(255,100,0);
	Canvas.SetPos(105,Canvas.ClipY-249-YL/2);
	Canvas.DrawText(int(GRI.LowKillZ));
	Canvas.SetPos(50,Canvas.ClipY-251);
	Canvas.DrawTile(texture'GradL',25,2,0,0,255,0);
	Canvas.SetPos(75,Canvas.ClipY-251);
	Canvas.DrawTile(texture'GradR',25,2,0,0,255,0);
	if ((GRI.LowKillZ<Owner.Location.Z)&&(Owner.Location.Z<GRI.HiKillZ))
		{
		LocDelta=(Owner.Location.Z-Gri.LowKillZ)/(Gri.HiKillZ-Gri.LowKillZ);
		Canvas.DrawColor=GetC(0,255,0);
		Canvas.SetPos(105,Int(Canvas.ClipY-250-LocDelta*100)-YL/2);
		Canvas.DrawText(int(Owner.Location.Z));
		Canvas.SetPos(50,Int(Canvas.ClipY-250-LocDelta*100));
		Canvas.DrawTile(texture'GradL',25,1,0,0,255,0);
		Canvas.SetPos(75,Int(Canvas.ClipY-250-LocDelta*100));
		Canvas.DrawTile(texture'GradR',25,1,0,0,255,0);
		}
	}
	else
	{
	if (Abs(GRI.HiKillZ-Owner.Location.Z)<AltScale)
	{
	LocDelta=(GRI.HiKillZ-Owner.Location.Z)/AltScale;
	Canvas.DrawColor=GetC(0,100,255);
	Canvas.SetPos(105,Canvas.ClipY-300-YL/2-LocDelta*50);
	Canvas.DrawText(int(GRI.HiKillZ));
	Canvas.SetPos(50,Canvas.ClipY-300-50);
	Canvas.DrawTile(texture'GradL',25,1+(1-LocDelta)*50,0,0,255,0);
	Canvas.SetPos(75,Canvas.ClipY-300-50);
	Canvas.DrawTile(texture'GradR',25,1+(1-LocDelta)*50,0,0,255,0);
	}
	else if (Owner.Location.Z>GRI.HiKillZ)
	{
	Canvas.DrawColor=GetC(0,100,255);
	Canvas.SetPos(50,Canvas.ClipY-300-50);
	Canvas.DrawTile(texture'GradL',25,1+100,0,0,255,0);
	Canvas.SetPos(75,Canvas.ClipY-300-50);
	Canvas.DrawTile(texture'GradR',25,1+100,0,0,255,0);
	}
	if (Abs(GRI.LowKillZ-Owner.Location.Z)<AltScale)
	{
	LocDelta=(Owner.Location.Z-GRI.LowKillZ)/AltScale;
	Canvas.DrawColor=GetC(255,100,0);
	Canvas.SetPos(105,Canvas.ClipY-300-YL/2+LocDelta*50);
	Canvas.DrawText(int(GRI.LowKillZ));
	Canvas.SetPos(50,Canvas.ClipY-300+LocDelta*50);
	Canvas.DrawTile(texture'GradL',25,1+(1-LocDelta)*50,0,0,255,0);
	Canvas.SetPos(75,Canvas.ClipY-300+LocDelta*50);
	Canvas.DrawTile(texture'GradR',25,1+(1-LocDelta)*50,0,0,255,0);
	}
	else if (Owner.Location.Z<GRI.LowKillZ)
	{
	Canvas.DrawColor=GetC(255,100,0);
	Canvas.SetPos(50,Canvas.ClipY-300-50);
	Canvas.DrawTile(texture'GradL',25,1+100,0,0,255,0);
	Canvas.SetPos(75,Canvas.ClipY-300-50);
	Canvas.DrawTile(texture'GradR',25,1+100,0,0,255,0);
	}
	Canvas.DrawColor=GetC(0,255,0);
	Canvas.SetPos(105,Int(Canvas.ClipY-250-50)-YL/2);
	Canvas.DrawText(int(Owner.Location.Z));
	Canvas.SetPos(50,Int(Canvas.ClipY-250-50));
	Canvas.DrawTile(texture'GradL',25,1,0,0,255,0);
	Canvas.SetPos(75,Int(Canvas.ClipY-250-50));
	Canvas.DrawTile(texture'GradR',25,1,0,0,255,0);
	}
}

function bool TraceIdentify(canvas Canvas)
{
	local actor Other;
	local vector HitLocation, HitNormal, X, Y, Z, StartTrace, EndTrace;

	StartTrace = Owner.Location;
	StartTrace.Z += Pawn(Owner).BaseEyeHeight;

	EndTrace = StartTrace + vector(Pawn(Owner).ViewRotation) * 1000.0;

	Other = Trace(HitLocation, HitNormal, EndTrace, StartTrace, true);

	if (Pawn(Other) != None)
	{
		IdentifyTarget = Pawn(Other);
		IdentifyFadeTime = 5.0;
	}

	if ( IdentifyFadeTime == 0.0 )
		return false;

	if ( (IdentifyTarget == None)||(IdentifyTarget.bHidden)||(IdentifyTarget.Health<1) )
		return false;

	return true;
}

static function bool WorldToScreen(Vector WorldLocation, Pawn ThePlayer,
     float ScreenWidth, float ScreenHeight, out float X, out float Y)
{
   local vector EyePos, RelativeToPlayer;
   local float Scale;
   local rotator VRot;
   local actor VAct;

   if (ThePlayer.IsA('PlayerPawn'))
   {
   PlayerPawn(ThePlayer).PlayerCalcView(VAct,EyePos,VRot);
   RelativeToPlayer = (WorldLocation - EyePos) << VRot;
   }
   else
   {
   EyePos = ThePlayer.Location;
   EyePos.Z += ThePlayer.BaseEyeHeight; // Maybe ThePlayer.EyeHeight instead?
   RelativeToPlayer = (WorldLocation - EyePos) << ThePlayer.ViewRotation;
   }

   if (RelativeToPlayer.X < 0.01)
      return false;

   Scale = (ScreenWidth / 2) / Tan(ThePlayer.FovAngle/2/180*Pi);

   X = RelativeToPlayer.Y / RelativeToPlayer.X * Scale + ScreenWidth / 2;
   Y = - RelativeToPlayer.Z / RelativeToPlayer.X * Scale + ScreenHeight / 2;

   return true;
}

static function GetBoundingBox(Pawn Player, actor What, canvas C, out float BU,
								out float BD, out float BL, out float BR)
{
	local int I;
	local vector PossibleV[16];
	local float CR, CH, TX, TY;
	local vector X,Y,Z;
	local rotator Rt;
	local float U,D,L,R;
	CR=What.CollisionRadius; CH=What.CollisionHeight;
	Rt=Rotator(What.Location-Player.Location); Rt.Roll=0; Rt.Pitch=0;
	GetAxes(Rt,X,Y,Z);
	X*=CR; Y*=CR; Z*=CH;
	PossibleV[0]=What.Location;
	PossibleV[1]=PossibleV[0];
		PossibleV[2]=PossibleV[1]-X;
			PossibleV[6]=PossibleV[2]+Z;
			PossibleV[7]=PossibleV[2]-Z;
		PossibleV[3]=PossibleV[1]+X;
			PossibleV[8]=PossibleV[3]+Z;
			PossibleV[9]=PossibleV[3]-Z;
		PossibleV[4]=PossibleV[1]-Y;
			PossibleV[10]=PossibleV[4]+Z;
			PossibleV[11]=PossibleV[4]-Z;
		PossibleV[5]=PossibleV[1]+Y;
			PossibleV[12]=PossibleV[5]+Z;
			PossibleV[13]=PossibleV[5]-Z;
		PossibleV[14]=PossibleV[1]+Z;
		PossibleV[15]=PossibleV[1]-Z;
	U=10000; L=10000; D=-10000; R=-10000;
	for (I=1;I<16;I++)
	{
	WorldToScreen(PossibleV[i],Player,C.ClipX,C.ClipY,TX,TY);
	if (TX<L) L=TX; if (TX>R) R=TX;
	if (TY<U) U=TY; if (TY>D) D=TY;
	}
	BU=U; BD=D; BL=L; BR=R;
}

function DrawIdentifyInfo(canvas Canvas, float PosX, float PosY)
{
	local float XL, YL, XOffset;
	local float BU,BD,BL,BR;
	local float HPPct, Dist, HH;

	if (!TraceIdentify(Canvas))
		return;

	if (IdentifyTarget==None)
		return;

	Canvas.Font = WhiteFont;
	Canvas.Style = 3;

	//if (DPlayer(Owner)!=None)
	//	DPlayer(Owner).UpdateIdentFor(IdentifyTarget,IdentifyTarget.MenuName);

	GetBoundingBox(Pawn(Owner),IdentifyTarget,Canvas,BU,BD,BL,BR);
	if (BU==0) if (BL==0) return;
	Dist=VSize(IdentifyTarget.Location-Owner.Location);
	Dist/=1000;
	if (Dist>1) HH=0;
	else
	HH=(1-Dist)*8;

	if (IdentifyTarget.IsA('DPlayer'))
		Canvas.DrawColor=GetC(0,255,0);
	else if (IdentifyTarget.IsA('Bots'))
		Canvas.DrawColor=GetC(255,255,0);
	else if (IdentifyTarget.IsA('Cow'))
		Canvas.DrawColor=GetC(255,255,0);
	else if (IdentifyTarget.IsA('Nali'))
		Canvas.DrawColor=GetC(0,255,0);
	else if (IdentifyTarget.IsA('NaliRabbit'))
		Canvas.DrawColor=GetC(255,255,0);
	else
		Canvas.DrawColor=GetC(255,0,0);
	Canvas.DrawColor.R=byte(Float(Canvas.DrawColor.R)*(IdentifyFadeTime/5));
	Canvas.DrawColor.G=byte(Float(Canvas.DrawColor.G)*(IdentifyFadeTime/5));
	//Canvas.DrawColor.B=byte(Float(Canvas.DrawColor.B)*(IdentifyFadeTime/5));

	Canvas.SetPos(BL,BU);
	Canvas.DrawTile(texture'WhiteTexture',BR-BL,1,0,0,1,1);
	Canvas.SetPos(BL,BD-1);
	Canvas.DrawTile(texture'WhiteTexture',BR-BL,1,0,0,1,1);
	Canvas.SetPos(BL,BU);
	Canvas.DrawTile(texture'WhiteTexture',1,BD-BU,0,0,1,1);
	Canvas.SetPos(BR-1,BU);
	Canvas.DrawTile(texture'WhiteTexture',1,BD-BU,0,0,1,1);

	if (BR-BL>64)
	{
	Canvas.Style=3;
	//Canvas.DrawColor=GetC(127,127,127,255);
	//Canvas.SetPos(BL+16,BU-HH-4);
	//Canvas.DrawTile(texture'WhiteTexture',BR-BL-32,HH,0,0,1,1);
	Canvas.SetPos(BL+1+16,BU-HH-3);
	HPPct=float(IdentifyTarget.Health)/float(IdentifyTarget.default.Health);
	HPPct=FClamp(HPPct,0,1);
	Canvas.DrawColor=GetC(255*(1-HPPct),255*HPPct,0);
	Canvas.DrawColor.R=byte(Float(Canvas.DrawColor.R)*(IdentifyFadeTime/5));
	Canvas.DrawColor.G=byte(Float(Canvas.DrawColor.G)*(IdentifyFadeTime/5));
	//Canvas.DrawColor.B=byte(Float(Canvas.DrawColor.B)*(IdentifyFadeTime/5));
	Canvas.DrawTile(texture'WhiteTexture',HPPct*(BR-BL-2-32),HH-2,0,0,1,1);
	}
	else
	{
	Canvas.Style=3;
	//Canvas.DrawColor=GetC(127,127,127,255);
	//Canvas.SetPos(BL+(BR-BL)/2-15,BU-HH-4);
	//Canvas.DrawTile(texture'WhiteTexture',32,Hh,0,0,1,1);
	Canvas.SetPos(BL+1+(BR-BL)/2-15,BU-HH-3);
	HPPct=float(IdentifyTarget.Health)/float(IdentifyTarget.default.Health);
	HPPct=FClamp(HPPct,0,1);
	Canvas.DrawColor=GetC(255*(1-HPPct),255*HPPct,0);
	Canvas.DrawColor.R=byte(Float(Canvas.DrawColor.R)*(IdentifyFadeTime/5));
	Canvas.DrawColor.G=byte(Float(Canvas.DrawColor.G)*(IdentifyFadeTime/5));
	//Canvas.DrawColor.B=byte(Float(Canvas.DrawColor.B)*(IdentifyFadeTime/5));
	Canvas.DrawTile(texture'WhiteTexture',HPPct*(30),HH-2,0,0,1,1);
	}

	if (IdentifyTarget.IsA('DPlayer'))
		Canvas.DrawColor=GetC(0,255,0);
	else if (IdentifyTarget.IsA('Bots'))
		Canvas.DrawColor=GetC(255,255,0);
	else if (IdentifyTarget.IsA('Cow'))
		Canvas.DrawColor=GetC(255,255,0);
	else if (IdentifyTarget.IsA('Nali'))
		Canvas.DrawColor=GetC(0,255,0);
	else if (IdentifyTarget.IsA('NaliRabbit'))
		Canvas.DrawColor=GetC(255,255,0);
	else
		Canvas.DrawColor=GetC(255,0,0);
	Canvas.DrawColor.R=byte(Float(Canvas.DrawColor.R)*(IdentifyFadeTime/5));
	Canvas.DrawColor.G=byte(Float(Canvas.DrawColor.G)*(IdentifyFadeTime/5));

	if (IdentifyTarget.MenuName=="")
		IdentifyTarget.MenuName=Mid(String(IdentifyTarget.Class),InStr(String(IdentifyTarget.Class),".")+1);

	if (IdentifyTarget.PlayerReplicationInfo!=None)
	if (IdentifyTarget.PlayerReplicationInfo.PlayerName!="")
	IdentifyTarget.MenuName=IdentifyTarget.PlayerReplicationInfo.PlayerName;

	Canvas.StrLen(IdentifyTarget.MenuName$" ("$IdentifyTarget.Health$")",XL,YL);
	Canvas.SetPos(BL+(BR-BL)/2-XL/2,BD+4);
	Canvas.DrawText(IdentifyTarget.MenuName);

	Canvas.DrawColor=GetC(255*(1-HPPct),255*HPPct,0);
	Canvas.DrawColor.R=byte(Float(Canvas.DrawColor.R)*(IdentifyFadeTime/5));
	Canvas.DrawColor.G=byte(Float(Canvas.DrawColor.G)*(IdentifyFadeTime/5));

	Canvas.StrLen(IdentifyTarget.MenuName$" ",XOffset,YL);
	Canvas.SetPos(BL+(BR-BL)/2-XL/2+XOffset,BD+4);
	Canvas.DrawText("("$IdentifyTarget.Health$")");

	Canvas.Style = 1;
	Canvas.DrawColor.R = 255;
	Canvas.DrawColor.G = 255;
	Canvas.DrawColor.B = 255;

}

function CallPRIDraw(DScoreBoard SBD, Canvas Canvas)
{
	local int I;
	for (I=0;I<PriCount;I++)
		SBD.DrawPri(Canvas,ArPri[I],I);
}

event Timer()
{
	local int C,D;
	local actor A;
	local DPRI PRI;
	C=0; D=0;
	foreach AllActors(class'Actor',A)
	{
	if (A.IsA('DPRI'))
	{ PRI=DPRI(A);
	if ((!PRI.bInvisible)||(PRI==Pawn(Owner).PlayerReplicationInfo))
	if (PRI.UserName!="DCoop")
		ArPri[C++]=Pri; }
	if (A.IsA('RadPoint'))
		ArRad[D++]=RadPoint(A);
	}
	PriCount=C;
	for (C=C;C<64;C++)
		ArPri[C]=None;
	for (D=D;D<64;D++)
		ArRad[D]=None;
	if (DPlayer(Owner)!=None)
	DPlayer(Owner).myPRI.UpdTime(Level.Year,Level.Month,Level.Day,Level.Hour,Level.Minute,Level.Second);
}

event PreBeginPlay()
{
	super.PreBeginPlay();
	SetTimer(1,True);
	Timer();
}

function color GetC(byte R, byte G, byte B, optional byte A)
{
local color C;
C.R=R;
C.G=G;
C.B=B;
C.A=A;
return c;
}

//==============================================================================
// Message stack handling intf

function CheckMessages()
{
	local int I;
  	for (I=0;I<100;I++)
  	if ( Msgs[I].bAlive )
  	if ( EliminateYet(I) )
  	{
		KillMsg(I);
  		MsgShift(I);
  	}
}

function bool EliminateYet(int I)
{
	if (Level.TimeSeconds<Msgs[I].RecvTime)
		return true; /* !!! */
	if (Level.TimeSeconds-Msgs[I].RecvTime>DPlayer(Owner).MsgLife)
		if (Msgs[I].XMessageClass==None)
			return true;
	if (Msgs[I].XMessageClass!=None)
		if (Level.TimeSeconds-Msgs[I].RecvTime>Msgs[I].XMessageClass.default.LifeTime)
			return true;
	return false;
}

function KillMsg(int I)
{
	Msgs[I].bAlive=False;
	Msgs[I].PRI=None;
	Msgs[I].Msg="";
	Msgs[I].N='';
	Msgs[I].XMessageClass=None;
	Msgs[I].O1=None;
	Msgs[I].O2=None;
	Msgs[I].O3=None;
	Msgs[I].Sw=0;
	Msgs[I].RecvTime=0;
}

function MsgShift(int M)
{
	local int I;
	if (M<0) return; if (M>98) return;
	for (I=M;I<99;I++)
		if (!Msgs[I].bAlive)
		{
			if (Msgs[I+1].bAlive)
			{
				/* Another shift */
				Msgs[I]=Msgs[I+1];
				KillMsg(I+1);
			}
			else
			{
				/* Final shift */
				return;
			}
		}
}

function AddMessage ( PlayerReplicationInfo PRI, string Msg, name N, float RecvTime )
{
	local int I;
	if (N=='Console') return;  //Dont spam
	if (N=='Log') return;      //My stack
	if (N=='') return;         //With BS
	for (I=0;I<100;I++)
	if (!Msgs[I].bAlive)
	{
		if (InStr(Caps(String(N)),"SAY")>-1)
		if (PRI!=None)
		if (PRI.IsA('DPRI'))
		{
		LastFace=DPRI(PRI).FaceTexture;
		LastDFace=DPRI(PRI).FaceClass;
		LastFaceTime=Level.TimeSeconds;
		}
		Msgs[I].bAlive=True;
		Msgs[I].PRI=PRI;
		Msgs[I].Msg=Msg;
		if (N=='TeamSay') N='Say'; //TeamSay in Coop? LOL?!
		Msgs[I].N=N;
		Msgs[I].RecvTime=RecvTime;
		return;
	}
}

function Message ( PlayerReplicationInfo PRI, coerce string Msg, name N )
{
	AddMessage(PRI,MSG,N,Level.TimeSeconds);
	/* Handled in RecvMsg */
	/* Only must be called if transmission to RecvMsg failed */
}

/* Those two should be called client-side */
function RecvMsg ( PlayerReplicationInfo PRI, coerce string Msg, name N )
{
	AddMessage(PRI,MSG,N,Level.TimeSeconds);
}

function RecvXMsg ( coerce string Msg, object O1, object O2, object O3,
						int Sw, class<DXMessage> MsgClass)
{
	local int I;
	for (I=0;I<100;I++)
	if (!Msgs[I].bAlive)
	{
		Msgs[I].bAlive=True;
		Msgs[I].Msg=Msg;
		Msgs[I].RecvTime=Level.TimeSeconds;
		Msgs[I].O1=O1;
		Msgs[I].O2=O2;
		Msgs[I].O3=O3;
		Msgs[I].Sw=Sw;
		Msgs[I].XMessageClass=MsgClass;
		if (DPlayer(Owner)!=None)
		MsgClass.default.MyPlayer=DPlayer(Owner);
		MsgClass.default.MyHud=Self;
		return;
	}
}

function int GetMsgStack(int I)
{
	if (Msgs[I].XMessageClass!=None)
		return Msgs[I].XMessageClass.default.iMsgPlace;

	/* Stack 0 */
	if (Msgs[I].N=='Console') return 0;
	if (Msgs[I].N=='Log') return 0;
	//if (Msgs[I].N=='') return 0; //que the f..

	/* Stack 1 */
	//All messages by default get in here. Dont condite.

	/* Stack 2 */
	if (Msgs[I].N=='CriticalEvent') return 2;
	if (Msgs[I].N=='EndCountdownIM') return 2;
	if (Msgs[I].N=='EndCountdown') return 2;

	/* Stack 3 */
	if (Msgs[I].N=='LowCriticalEvent') return 3;

	/* Stack 4 */
	if (Msgs[I].N=='Pickup') return 4;
	if (Msgs[I].N=='RedCriticalEvent') return 4;

	/* Stack 5 */
    if (Msgs[I].N=='MultiKill') return 5;
    if (Msgs[I].N=='KillingSpree') return 5;

	/* default Stack 1 */
	return 1; /* By default all unknown messages are placed into Stack1 */
}

// Message stack handling intf
//==============================================================================

function color FadeCtrl(int I, color C)
{
	local float FA;
	local float ML;
	local color FC;
	/* Those two shouldnt fade, return C */
	if (Msgs[I].XMessageClass!=None)
		if (!Msgs[I].XMessageClass.default.bFadeOut)
			return C;
	if (Msgs[I].XMessageClass==None)
		if (!DPlayer(Owner).SSMFade)
			return C;
	/* Calculate 0<=FadeAlpha<=1 */
	if (Msgs[I].XMessageClass==None)
		ML=DPlayer(Owner).MsgLife;
	else
		ML=Msgs[I].XMessageClass.default.LifeTime;
	/* Get, assign */
 	FA=FClamp(((Msgs[I].RecvTime+ML)-Level.TimeSeconds),0,1);
 	FC.R=C.R*FA;
 	FC.G=C.G*FA;
 	FC.B=C.B*FA;
 	FC.A=C.A;
 	/* Return */
 	return FC;
}

function DrawSayMsg(int I, canvas C, float X, float Y)
{
	local float lX, lY;
	local string PriStr;
	C.SetPos(X,Y);
	if (Msgs[I].N=='Say') C.DrawColor=FadeCtrl(I,GetC(128,255,128));
	if (Msgs[I].N=='SFXSay') C.DrawColor=FadeCtrl(I,GetC(RByte(),RByte(),RByte()));
	if (Msgs[I].N=='L1Say') C.DrawColor=FadeCtrl(I,GetC(255,164,0));
	if (Msgs[I].N=='L2Say') C.DrawColor=FadeCtrl(I,GetC(255,164,0));
	if (Msgs[I].N=='L3Say') C.DrawColor=FadeCtrl(I,GetC(255,164,0));
	if (Msgs[I].N=='L4Say') C.DrawColor=FadeCtrl(I,GetC(255,164,0));
	if (Msgs[I].N=='L5Say') C.DrawColor=FadeCtrl(I,GetC(255,164,0));
	if (Msgs[I].N=='PSay') C.DrawColor=FadeCtrl(I,GetC(255,255,128));
	if (Msgs[I].N=='CSay') C.DrawColor=FadeCtrl(I,GetC(128,255,255));
	lX=0;
	if (Msgs[I].PRI!=None)
		{
		if (Msgs[I].N=='Say') PriStr=Msgs[I].PRI.PlayerName$": ";
		if (Msgs[I].N=='SFXSay') PriStr="*"$Msgs[I].PRI.PlayerName$"*: ";
		if (Msgs[I].N=='L1Say') PriStr=Msgs[I].PRI.PlayerName$" (L1Chat): ";
		if (Msgs[I].N=='L2Say') PriStr=Msgs[I].PRI.PlayerName$" (L2Chat): ";
		if (Msgs[I].N=='L3Say') PriStr=Msgs[I].PRI.PlayerName$" (L3Chat): ";
		if (Msgs[I].N=='L4Say') PriStr=Msgs[I].PRI.PlayerName$" (L4Chat): ";
		if (Msgs[I].N=='L5Say') PriStr=Msgs[I].PRI.PlayerName$" (L5Chat): ";
		if (Msgs[I].N=='PSay') PriStr=Msgs[I].PRI.PlayerName$" (Private): ";
		if (Msgs[I].N=='CSay') PriStr=Msgs[I].PRI.PlayerName$" (Whisper): ";
		}
	else
		PriStr="None: ";
	C.StrLen(PriStr,lX,lY);
	C.DrawText(PriStr);
	C.SetPos(X+lX,Y);
	if (Msgs[I].N=='Say') C.DrawColor=FadeCtrl(I,GetC(64,255,64));
	if (Msgs[I].N=='SFXSay') C.DrawColor=FadeCtrl(I,GetC(RByte(),RByte(),RByte()));
	if (Msgs[I].N=='L1Say') C.DrawColor=FadeCtrl(I,GetC(164,64,0));
	if (Msgs[I].N=='L2Say') C.DrawColor=FadeCtrl(I,GetC(164,64,0));
	if (Msgs[I].N=='L3Say') C.DrawColor=FadeCtrl(I,GetC(164,64,0));
	if (Msgs[I].N=='L4Say') C.DrawColor=FadeCtrl(I,GetC(164,64,0));
	if (Msgs[I].N=='L5Say') C.DrawColor=FadeCtrl(I,GetC(164,64,0));
	if (Msgs[I].N=='PSay') C.DrawColor=FadeCtrl(I,GetC(255,255,0));
	if (Msgs[I].N=='CSay') C.DrawColor=FadeCtrl(I,GetC(0,255,255));
	C.DrawText(Msgs[I].Msg);
}

function DrawMsg(int I, canvas C, float X, float Y)
{
	C.DrawColor=FadeCtrl(I,C.DrawColor);
	C.SetPos(X,Y);
	if (Msgs[I].XMessageClass==None)
		C.DrawText(Msgs[I].Msg);
	else
	{
	C.DrawColor=Msgs[I].XMessageClass.static.RetColor(Msgs[I].Msg,Msgs[I].O1,Msgs[I].O2,Msgs[I].O3,Msgs[I].Sw);
	C.DrawColor=FadeCtrl(I,C.DrawColor);
	if (!Msgs[I].XMessageClass.default.bComplexMessage)
		{
		C.DrawText(Msgs[I].XMessageClass.static.GetMessage(Msgs[I].Msg,Msgs[I].O1,Msgs[I].O2,Msgs[I].O3,Msgs[I].Sw));
		}
	else
		Msgs[I].XMessageClass.static.Render(C,Msgs[I].Msg,Msgs[I].O1,Msgs[I].O2,Msgs[I].O3,Msgs[I].Sw);
	}
}

function color GetECC(string Msg)
{
local int I,J;
local string S;
S=Msg;
J=InStr(S,".");
if (J>-1) S=Left(S,J);
I=int(S);
switch (I)
{
case 10: return GetC(0,255,0); break;
case 9: return GetC(26,230,0); break;
case 8: return GetC(51,204,0); break;
case 7: return GetC(77,179,0); break;
case 6: return GetC(102,153,0); break;
case 5: return GetC(128,128,0); break;
case 4: return GetC(153,102,0); break;
case 3: return GetC(179,77,0); break;
case 2: return GetC(204,51,0); break;
case 1: return GetC(230,26,0); break;
case 0: return GetC(255,0,0); break;
}
return GetC(255,255,0);
}

function byte RByte()
{
return byte(int(RandRange(0,255)));
}

function RecalcFace()
{
/*
Face should fade out in following pattern:
0 -> DPlayer(Owner).MsgLife = 128
ML -> (ML+1) = Linear Interpolation between 128 and 0 (1 - (TS - FR - ML))
*/
/*C.Style=1;
C.DrawColor=GetC(255,255,255,255);*/
if (LastFace==None) if (LastDFace==None) { FaceOff=0; return; }
if ((Level.TimeSeconds - LastFaceTime) > (DPlayer(Owner).MsgLife + 1)) { FaceOff=0; return; }
if ((Level.TimeSeconds - LastFaceTime) < DPlayer(Owner).MsgLife) FaceOff=128;
else
FaceOff=FClamp(Lerp(Level.TimeSeconds-LastFaceTime-DPlayer(Owner).MsgLife,128,-128),0,128);
/*if (FaceOff>0)
{
C.SetPos(-128+FaceOff,0);
if (LastDFace==None)
	{ if (LastFace!=None) C.DrawTile(LastFace,128,128,0,0,LastFace.USize,LastFace.VSize); }
else
	LastDFace.static.RenderFace(C,-128+FaceOff,0,128,128);
}*/
}

function DrawFace( canvas C )
{
/*
Face should fade out in following pattern:
0 -> DPlayer(Owner).MsgLife = 128
ML -> (ML+1) = Linear Interpolation between 128 and 0 (1 - (TS - FR - ML))
*/
C.Style=1;
C.DrawColor=GetC(255,255,255,255);
/*if (LastFace==None) if (LastDFace==None) { FaceOff=0; return; }
if ((Level.TimeSeconds - LastFaceTime) > (DPlayer(Owner).MsgLife + 1)) { FaceOff=0; return; }
if ((Level.TimeSeconds - LastFaceTime) < DPlayer(Owner).MsgLife) FaceOff=128;
else
FaceOff=FClamp(Lerp(Level.TimeSeconds-LastFaceTime-DPlayer(Owner).MsgLife,128,-128),0,128);*/
if (FaceOff>0)
{
C.SetPos(-128+FaceOff,0);
if (LastDFace==None)
	{ if (LastFace!=None) C.DrawTile(LastFace,128,128,0,0,LastFace.USize,LastFace.VSize); }
else
	LastDFace.static.RenderFace(C,-128+FaceOff,0,128,128);
}
}

function color GetSCB()
{
local byte M;
local float D;
local color C;
C=DPlayer(Owner).ServerColor;
if (C.R>M) M=C.R;
if (C.G>M) M=C.G;
if (C.B>M) M=C.B;
D=float(M)/32;
C.R=byte(float(C.R)/D);
C.G=byte(float(C.G)/D);
C.B=byte(float(C.B)/D);
C.A=255;
return C;
}

function bool DisplayMessages( canvas Canvas )
{
	local console Console;
	local int I,C;
	local int Stack1[8]; // Pointers to Stack1 entries
	local int Stack2[5]; // Pointers to Stack2 entries
	local int Stack3[5]; // Pointers to Stack3 entries
	local int Stack4[5]; // Pointers to Stack4 entries
	local int Stack5[5]; // Pointers to Stack4 entries
	local float tX, tY, tpX, tpY, MKC, CX;
	local string TypingPrompt;

	for (I=0;I<8;I++)
	{
		Stack1[I]=-1;
		if (I<5)
		{
			Stack2[I]=-1;
			Stack3[I]=-1;
			Stack4[I]=-1;
			Stack5[I]=-1;
		}
	}

	RecalcFace();

	Console = PlayerPawn(Owner).Player.Console;
	if (Console==None)
		return false;

	Canvas.Font = WhiteFont;
	Canvas.StrLen("C",tX,tY);
	Canvas.Style=1;

	if ( !Console.Viewport.Actor.bShowMenu )
	{
	if ( Console.Viewport.Actor.bShowScores )
		DrawSemiTypingPrompt(Canvas, Console);
	else
		DrawTypingPrompt(Canvas, Console);
	}

	if ( !Console.Viewport.Actor.bShowMenu || Console.Viewport.Actor.bShowScores )
	{
		/* Process Messages and put them into Stack# */
			/* Stack entries 1: Chat box */
			/* Stack order: Normal */
			C=0;
			for (I=0;(I<100 && C<8);I++)
				if (Msgs[I].bAlive)
					if (GetMsgStack(I)==1)
						Stack1[C++]=I;

			/* Stack entries 2: CriticalEvent */
            /* Stack order: Inverted */
			C=0;
			for (I=99;(I>-1 && C<5);I--)
				if (Msgs[I].bAlive)
					if (GetMsgStack(I)==2)
						Stack2[C++]=I;

			/* Stack entries 3: LowCriticalEvent */
            /* Stack order: Inverted */
			C=0;
			for (I=99;(I>-1 && C<5);I--)
				if (Msgs[I].bAlive)
					if (GetMsgStack(I)==3)
						Stack3[C++]=I;

			/* Stack entries 4: Pickup \ RCI */
            /* Stack order: Inverted */
			C=0;
			for (I=99;(I>-1 && C<5);I--)
				if (Msgs[I].bAlive)
					if (GetMsgStack(I)==4)
						Stack4[C++]=I;

			/* Stack entries 5: MultiKills \ Sprees */
            /* Stack order: Inverted */
			C=0;
			for (I=99;(I>-1 && C<5);I--)
				if (Msgs[I].bAlive)
					if (GetMsgStack(I)==5)
						Stack5[C++]=I;

		/* Preparation complete. Stack# arrays are now initialized */

		/* Do transparency in case some msgs should fade out */
		Canvas.Style=3;

		/* Now draw messages on screen, use Stacks */
			/* Draw Stack1 entries: Chat box */

			/* Before drawing actual stack lets draw a sw33t tex */
			if (!PlayerPawn(Owner).bShowScores)
			if ( (Console.bTyping) || (Stack1[0]!=-1) )
			{
//			Canvas.SetPos(0,0);
			Canvas.DrawColor=GetSCB();

			/* Evade inventory: */
			/* Episode 1 */
			Canvas.SetPos(0,32);
			Canvas.DrawTile(texture'GradD',Canvas.ClipX,tY*8+16-32,0,0,2,256);
			/* Episode 2 */
			Canvas.SetPos(0,0);
			Canvas.DrawTile(texture'Base',Canvas.ClipX-96,32,0,0,2,256);
			if ( Console.bTyping )
			{
			TypingPrompt = "(> "$Console.TypedStr$"|";
			Canvas.StrLen(TypingPrompt,tpX,tpY);

			Canvas.SetPos(0,tY*8+16);
			Canvas.DrawTile(texture'GradU',Canvas.ClipX,tpY/2+1,0,0,2,256);

			Canvas.SetPos(0,tY*8.5+17);
			Canvas.DrawTile(texture'GradD',Canvas.ClipX,tpY/2+1,0,0,2,256);

			Canvas.SetPos(0, Console.FrameY - (Console.ConsoleLines + tpY + 2)*2);
			Canvas.DrawTile(texture'GradU',Canvas.ClipX,(tpY+2+Console.ConsoleLines)*2,0,0,2,256);
			}
			}

			/* Actual stack drawing */

            Canvas.StrLen("C",tX,tY);
			for (I=0;I<8;I++)
			if (Stack1[I]!=-1)
			{
				if (InStr(Caps(string(Msgs[Stack1[I]].N)),"SAY")>-1)
					DrawSayMsg(Stack1[I],Canvas,8+FaceOff,8+I*tY);
				Canvas.DrawColor=GetC(255,255,255);
				if (Msgs[Stack1[I]].N=='DeathMessage')
					Canvas.DrawColor=GetC(255,0,0);
				if (Msgs[Stack1[I]].N=='Error')
					Canvas.DrawColor=GetC(255,64,64);
				if (Msgs[Stack1[I]].N=='LevelEvent')
					Canvas.DrawColor=GetC(128,128,255);
				if (Msgs[Stack1[I]].N=='ServerEvent')
					Canvas.DrawColor=GetC(255,128,0);
				if (Msgs[Stack1[I]].N=='FailJoinMessage')
					Canvas.DrawColor=GetC(255,128,128);
				if (Msgs[Stack1[I]].N=='JoinMessage')
					Canvas.DrawColor=DPlayer(Owner).EnteredColor;
				if (Msgs[Stack1[I]].N=='LeaveMessage')
					Canvas.DrawColor=DPlayer(Owner).LeftColor;
				if (Msgs[Stack1[I]].N=='CREvent')
					Canvas.DrawColor=GetC(0,255,255);
				if (InStr(Caps(string(Msgs[Stack1[I]].N)),"SAY")==-1)
					DrawMsg(Stack1[I],Canvas,8+FaceOff,8+I*tY);
			}

			Canvas.bCenter=True;
			/* Draw Stack2 entries: CriticalEvent */
			Canvas.StrLen("C",tX,tY);
			for (I=0;I<5;I++)
			if (Stack2[I]!=-1)
			{
					Canvas.DrawColor=GetC(255,255,255);
				if (Msgs[Stack2[I]].N=='CriticalEvent')
					Canvas.DrawColor=GetC(0,64,255);
				if (Msgs[Stack2[I]].N=='EndCountdownIM')
					Canvas.DrawColor=GetC(255,255,0);
				if (Msgs[Stack2[I]].N=='EndCountdown')
					Canvas.DrawColor=GetECC(Msgs[Stack2[I]].Msg);
            	DrawMsg(Stack2[I],Canvas,0,Console.FrameY/2-32+I*tY);
			}

			/* Draw Stack3 entries: LowCriticalEvent */
			Canvas.StrLen("C",tX,tY);
			for (I=0;I<5;I++)
			if (Stack3[I]!=-1)
			{
					Canvas.DrawColor=GetC(255,255,255);
				if (Msgs[Stack3[I]].N=='LowCriticalEvent')
					Canvas.DrawColor=GetC(0,64,255);
				DrawMsg(Stack3[I],Canvas,0,Console.FrameY/2+32+I*tY);
			}

			Canvas.Font=font'UTLadder10';
			/* Draw Stack4 entries: Pickup \ RCI */
			Canvas.StrLen("C",tX,tY);
			for (I=0;I<5;I++)
			if (Stack4[I]!=-1)
			{
//				if (Msgs[Stack4[I]].N=='Pickup')
					Canvas.DrawColor=GetC(255,255,255);
				if (Msgs[Stack4[I]].N=='RedCriticalEvent')
					Canvas.DrawColor=GetC(255,64,64);
            	DrawMsg(Stack4[I],Canvas,0,Console.FrameY-64+I*tY);
			}

			Canvas.Font=Font'UTLadder20';
			/* Draw Stack5 entries: MultiKills \ Sprees */
            Canvas.StrLen("C",tX,tY);
			for (I=0;I<5;I++)
			if (Stack5[I]!=-1)
			{
               	if (Level.TimeSeconds-Msgs[Stack5[I]].RecvTime<0.5)
            	{
            	CX=Canvas.ClipX;
            	Canvas.ClipX=99999;
            	Canvas.bCenter=False;
                Canvas.StrLen(Msgs[Stack5[I]].Msg,tX,tY);
                MKC=FMax(0,1-(Level.TimeSeconds-Msgs[Stack5[I]].RecvTime)*2);
                Canvas.DrawColor=GetC(255*MKC,255*MKC,255*MKC);
                Canvas.SetPos(CX/2-tX/2-tX*(1-MKC),144+I*tY);
                Canvas.DrawText(Msgs[Stack5[I]].Msg);
                Canvas.SetPos(CX/2-tX/2+tX*(1-MKC),144+I*tY);
                Canvas.DrawText(Msgs[Stack5[I]].Msg);
                Canvas.bCenter=True;
                Canvas.ClipX=CX;
            	}
//                if (Msgs[Stack5[I]].N=='Que')
					Canvas.DrawColor=GetC(255,255,255);
				if (Msgs[Stack5[I]].N=='MultiKill')
					Canvas.DrawColor=GetC(255,0,0);
				if (Msgs[Stack5[I]].N=='KillingSpree')
				    Canvas.DrawColor=GetC(0,0,255);
            	DrawMsg(Stack5[I],Canvas,0,144+I*tY);

			}

			Canvas.Font=WhiteFont;
			Canvas.bCenter=False;

		/* Cancel transparency for Super successors */
		Canvas.Style=1;

		/* Finished drawing them on screen. Good job. */
	}

	DrawFace(Canvas);

	return true;
}

function color TPColor(canvas Canvas, console Console)
{
		Canvas.DrawColor=GetC(200,255,200);
		if (Left(Console.TypedStr,3) ~="Say") 				Canvas.DrawColor=GetC(64,255,64);
		if (Left(Console.TypedStr,7) ~="TeamSay") 			Canvas.DrawColor=GetC(64,255,64);
		if (Left(Console.TypedStr,10)~="Disconnect") 		Canvas.DrawColor=GetC(255,64,64);
		if (Left(Console.TypedStr,9) ~="Reconnect") 		Canvas.DrawColor=GetC(255,72,64);
		if (Left(Console.TypedStr,5) ~="Login") 			Canvas.DrawColor=GetC(255,255,64);
		if (Left(Console.TypedStr,6) ~="Logout") 			Canvas.DrawColor=GetC(255,255,64);
}

function DrawSemiTypingPrompt( canvas Canvas, console Console )
{
	local string TypingPrompt;
	local float XL, YL, Junk, xYL;

	if ( Console.bTyping )
	{
		TPColor(Canvas,Console);

		TypingPrompt = "(> "$Console.TypedStr$"|";
		Canvas.Font = WhiteFont;
		Canvas.StrLen( TypingPrompt, XL, YL );
// 		Canvas.StrLen( "|Module|", Junk, xYL );

		Canvas.SetPos( 2, Console.FrameY - Console.ConsoleLines - YL - 1 );
		Canvas.DrawText( TypingPrompt, false );

//		Canvas.SetPos( 2, xYL * 8 + 17 );
//		Canvas.DrawText( TypingPrompt, false );
	}
}

function DrawTypingPrompt( canvas Canvas, console Console )
{
	local string TypingPrompt;
	local float XL, YL, Junk, xYL;

	if ( Console.bTyping )
	{
		TPColor(Canvas,Console);

		TypingPrompt = "(> "$Console.TypedStr$"|";
		Canvas.Font = WhiteFont;
		Canvas.StrLen( TypingPrompt, XL, YL );
 		Canvas.StrLen( "|Module|", Junk, xYL );

		Canvas.SetPos( 2, Console.FrameY - Console.ConsoleLines - YL - 1 );
		Canvas.DrawText( TypingPrompt, false );

		Canvas.SetPos( 2, xYL * 8 + 17 );
		Canvas.DrawText( TypingPrompt, false );
	}
}

function DrawMOTD(Canvas Canvas)
{
	local GameReplicationInfo GRI;
	local float XL, YL;

	if(Owner == None) return;

	if ( (PlayerPawn(Owner).Scoring == None) && (PlayerPawn(Owner).ScoringType != None) )
		PlayerPawn(Owner).Scoring = Spawn(PlayerPawn(Owner).ScoringType, PlayerPawn(Owner));

	if(Owner.IsA('DPlayer'))
	if(DPlayer(Owner).Scoring!=None)
	Canvas.Font = DPlayer(Owner).Scoring.RegFont;
	else
	Canvas.Font = WhiteFont;
	Canvas.Style = 3;

	Canvas.DrawColor.R = MOTDFadeOutTime;
	Canvas.DrawColor.G = MOTDFadeOutTime;
	Canvas.DrawColor.B = MOTDFadeOutTime;

	Canvas.bCenter = true;

//	foreach AllActors(class'GameReplicationInfo', GRI)
	GRI=PlayerPawn(Owner).GameReplicationInfo;
	if (GRI!=None)
	{
		if (GRI.GameName != "Game")
		{
			Canvas.DrawColor.R = 0;
			Canvas.DrawColor.G = MOTDFadeOutTime / 2;
			Canvas.DrawColor.B = MOTDFadeOutTime;
			Canvas.SetPos(0.0, 16);
			Canvas.StrLen("TEST", XL, YL);
			if (Level.NetMode != NM_Standalone)
				Canvas.DrawText(GRI.ServerName);
			Canvas.DrawColor.R = MOTDFadeOutTime;
			Canvas.DrawColor.G = MOTDFadeOutTime;
			Canvas.DrawColor.B = MOTDFadeOutTime;

			Canvas.SetPos(0.0, 16 + YL);
			Canvas.DrawText("Game Type: "$GRI.GameName, true);
			Canvas.SetPos(0.0, 16 + 2*YL);
			Canvas.DrawText("Map Title: "$Level.Title, true);
			Canvas.SetPos(0.0, 16 + 3*YL);
			Canvas.DrawText("Author: "$Level.Author, true);
			Canvas.SetPos(0.0, 16 + 4*YL);
			if (Level.IdealPlayerCount != "")
				Canvas.DrawText("Ideal Player Load:"$Level.IdealPlayerCount, true);

			Canvas.DrawColor.R = 0;
			Canvas.DrawColor.G = MOTDFadeOutTime / 2;
			Canvas.DrawColor.B = MOTDFadeOutTime;

			Canvas.SetPos(0, 32 + 6*YL);
			Canvas.DrawText(Level.LevelEnterText, true);

			Canvas.SetPos(0.0, 32 + 8*YL);
			Canvas.DrawText(GRI.MOTDLine1, true);
			Canvas.SetPos(0.0, 32 + 9*YL);
			Canvas.DrawText(GRI.MOTDLine2, true);
			Canvas.SetPos(0.0, 32 + 10*YL);
			Canvas.DrawText(GRI.MOTDLine3, true);
			Canvas.SetPos(0.0, 32 + 11*YL);
			Canvas.DrawText(GRI.MOTDLine4, true);
		}
	}
	Canvas.bCenter = false;

	Canvas.Style = 1;
	Canvas.DrawColor.R = 255;
	Canvas.DrawColor.G = 255;
	Canvas.DrawColor.B = 255;
}

function DisplayProgressMessage( canvas Canvas )
{
	local int i;
	local float YOffset, XL, YL;

	Canvas.DrawColor.R = 255;
	Canvas.DrawColor.G = 255;
	Canvas.DrawColor.B = 255;
	Canvas.bCenter = true;
	Canvas.Font = WhiteFont;
	YOffset = 0;
	Canvas.StrLen("TEST", XL, YL);
	for (i=0; i<5; i++)
	{
		Canvas.SetPos(0, 0.25 * Canvas.ClipY + YOffset);
		Canvas.DrawColor = PlayerPawn(Owner).ProgressColor[i];
		if (Canvas.DrawColor.R==255)
		if (Canvas.DrawColor.G==255)
		if (Canvas.DrawColor.B==255)
		Canvas.DrawColor=GetC(128,255,128);
		Canvas.DrawText(PlayerPawn(Owner).ProgressMessage[i], false);
		YOffset += YL + 1;
	}
	Canvas.bCenter = false;
	Canvas.DrawColor.R = 255;
	Canvas.DrawColor.G = 255;
	Canvas.DrawColor.B = 255;
}

function int GetHp()
{
if (Pawn(Owner)==None) return 0;
if (Pawn(Owner).Health<0) return 0;
return Pawn(Owner).Health;
}

function GetArmor(out int Ch, out int MCh)
{
	local inventory Inv;
	local int C, MC;
	C=0; MC=0;
	for( Inv=Owner.Inventory; Inv!=None; Inv=Inv.Inventory )
		if (Inv.bIsAnArmor)
		{
			C += int(float(Inv.Charge)*(float(Inv.ArmorAbsorption)/100));
			MC += int(float(Inv.default.Charge)*(float(Inv.ArmorAbsorption)/100));
		}
	Ch=C; MCh=MC;
}

exec function U2Hud()
{
HudMode=0;
SaveConfig();
}

function DrawU2Hud(canvas C)
{
	local texture HT;
	local float XL, YL, R;
	local float HPct, SPct, APct;
	local int AC, AMC;
	local float ff;
	C.Style=3;
	C.DrawColor=GetC(255,255,255,255);
	C.Font=WhiteFont;
	C.StrLen("Unreal2!",XL,YL);
	//HT=texture'Unreal2Hud';
	R=YL*9+16;

	//=================//
	// Draw health     //
	C.SetPos(4,C.ClipY-25);
	//C.DrawTile(HT,185,21,2,76,185,21);
	//Health Indicator = Use 'U2Indicators'
	C.DrawTile(texture'U2Indicators',185,21,0,42,185,21);
	C.Font=Font'TahomaB10';
	C.StrLen(GetHp(),XL,YL);
	C.SetPos(30.4-XL/2,C.ClipY-24);
	if (XL<32)
	C.DrawText(GetHp());
	else
	{
	C.StrLen("MAX",XL,YL);
	C.SetPos(30.4-XL/2,C.ClipY-24);
	C.DrawText("MAX");
	}
	if (GetHp()<32)
	C.DrawColor=GetC(255,0,0,255);
	if (bBlink || GetHp()>31)
	{
	if (float(GetHp())/float(Pawn(Owner).default.Health)<=1)
	{
	HPct=FClamp(float(GetHp())/float(Pawn(Owner).default.Health),0,1);
	C.SetPos(52,C.ClipY-25);
	//C.DrawTile(HT,133*HPct,5,2,2,133*HPct,5);
	//Health Bar = Use 'U2Bars'
	C.DrawTile(texture'U2Bars',133*HPct,5,0,0,133*HPct,5);
	}
	else
	{
	HPct=FClamp(1-(float(GetHp())/float(Pawn(Owner).default.Health)-1),0,1);
	C.SetPos(52+(1-HPct)*133,C.ClipY-25);
	//C.DrawTile(HT,133*HPct,5,2+133*(1-HPct),2,133*HPct,5);
	//Health Bar = Use 'U2Bars'
	C.DrawTile(texture'U2Bars',133*HPct,5,133*(1-HPct),0,133*HPct,5);
	HPct=FClamp(float(GetHp())/float(Pawn(Owner).default.Health)-1,0,1);
	C.SetPos(52,C.ClipY-25);
	//C.DrawTile(HT,133*HPct,5,2,10,133*HPct,5);
	//Blue Health Bar = Use 'U2Bars'
	C.DrawTile(texture'U2Bars',133*HPct,5,0,5,133*HPct,5);
	}
	}
	C.DrawColor=GetC(255,255,255,255);
	// Draw health     //
	//=================//
	// Draw armor      //
	GetArmor(AC,AMC);
	C.SetPos(4,C.ClipY-25-23);
	//C.DrawTile(HT,185,21,3,101,185,21);
	//Armor Indicator = Use 'U2Indicators'
	C.DrawTile(texture'U2Indicators',185,21,0,63,185,21);
	C.Font=Font'TahomaB10';
	C.StrLen(AC,XL,YL);
	C.SetPos(30.4-XL/2,C.ClipY-24-23);
	if (XL<32)
	C.DrawText(AC);
	else
	{
	C.StrLen("MAX",XL,YL);
	C.SetPos(30.4-XL/2,C.ClipY-24-23);
	C.DrawText("MAX");
	}
	if (AMC>0 && AC>0)
	{
	SPct=FClamp(float(AC)/float(AMC),0,1);
	C.SetPos(52,C.ClipY-25-23);
	//C.DrawTile(HT,133*SPct,5,2,10,133*SPct,5);
	//Armor Bar = Use 'U2Bars'
	C.DrawTile(texture'U2Bars',133*SPct,5,0,5,133*SPct,5);
	}
	DrawArmor2(C,4,C.ClipY-25-23-36);
	C.DrawColor=GetC(255,255,255,255);
	// Draw armor      //
	//=================//
	// Draw ammo       //
	C.SetPos(C.ClipX-190,C.ClipY-25);
	//C.DrawTile(HT,186,21,1,51,186,21);
	//Ammo Indicator = Use 'U2Indicators'
	C.DrawTile(texture'U2Indicators',186,21,0,21,186,21);
	C.Font=Font'TahomaB10';
	if (Pawn(Owner).Weapon!=None)
	if (Pawn(Owner).Weapon.AmmoType!=None)
	{
	APct=FClamp(float(Pawn(Owner).Weapon.AmmoType.AmmoAmount)/float(Pawn(Owner).Weapon.AmmoType.MaxAmmo),0,1);
	C.StrLen(Pawn(Owner).Weapon.AmmoType.AmmoAmount,XL,YL);
	C.SetPos(C.ClipX-30-XL/2,C.ClipY-24);
	if (XL<32)
	C.DrawText(Pawn(Owner).Weapon.AmmoType.AmmoAmount);
	else
	{
	C.StrLen("MAX",XL,YL);
	C.SetPos(C.ClipX-30-XL/2,C.ClipY-24);
	C.DrawText("MAX");
	}
	}
	else
	{
	APct=0;
	C.StrLen("0",XL,YL);
	C.SetPos(C.ClipX-30-XL/2,C.ClipY-24);
	C.DrawText("0");
	}
	C.SetPos(C.ClipX-184+((1-APct)*133),C.ClipY-25);
	//C.DrawTile(HT,133*APct,5,377+(1-APct)*133,2,133*APct,5);
	//Ammo Bar - Use 'U2Bars'
	C.DrawTile(texture'U2Bars',133*APct,5,(1-APct)*133,10,133*APct,5);
	// Draw ammo       //
	//=================//
	// Draw weapon     //
	C.SetPos(C.ClipX-190,C.ClipY-61);
	//C.DrawTile(HT,49,32,265,35,49,32);
	//ItemDisplay - Use 'U2ItemDisp'
	C.DrawTile(texture'U2ItemDisp',49,32,0,32,49,32);

	C.SetPos(C.ClipX-190+49,C.ClipY-61);
	//C.DrawTile(HT,97,32,265+49,35,24,32);
	//ItemDisplay - Use 'U2ItemDisp'
	C.DrawTile(texture'U2ItemDisp',97,32,49,32,24,32);

	C.SetPos(C.ClipX-190+49+97,C.ClipY-61);
	//C.DrawTile(HT,40,32,265+49+24,35,40,32);
	//ItemDisplay - Use 'U2ItemDisp'
	C.DrawTile(texture'U2ItemDisp',40,32,73,32,40,32);

	if (Pawn(Owner).Weapon!=None)
	{
	C.ClipX+=1000;
	C.SetPos(C.ClipX-144-1000,C.ClipY-39);
	C.DrawText(Pawn(Owner).Weapon.ItemName);
	C.ClipX-=1000;
	if (!bDontDrawWeaponIcon)
	{
	if (WMA==None) WMA=Spawn(class'WeapMeshAct',Self,'');
	if (WMA!=None) if (PlayerPawn(Owner)!=None)
	{
	WMA.Update(PlayerPawn(Owner));
	ff=PlayerPawn(Owner).FovAngle;
	PlayerPawn(Owner).FovAngle=30;
	C.DrawClippedActor(WMA,False,49,32,C.ClipX-190,C.ClipY-61,True);
	PlayerPawn(Owner).FovAngle=ff;
	}
	}
	}
	// Draw weapon     //
	//=================//
	// Draw scores     //
	C.Font=font'TahomaB10';
	C.DrawColor=GetC(0,64,255);
	C.SetPos(124,C.ClipY-40);
	C.DrawText("S: "$int(DPlayer(Owner).myPRI.Score));
	C.SetPos(123,C.ClipY-17);
	C.DrawText("D: "$DPlayer(Owner).myPRI.DmgPts);
	// Draw scores     //
	//=================//
	// Draw inventory  //
	DrawHHBase(C,False);
	C.Style=1;
	DrawInventory2(C,C.ClipX-96,0,False);
	DrawHHBase(C,True);
	// Draw inventory  //
	//=================//
}

// Use THIS for Unreal 2 hud rendering
simulated function DrawInventory2(Canvas Canvas, int X, int Y, bool bDrawOne)
{
	local bool bGotNext, bGotPrev, bGotSelected;
	local inventory Inv,Prev, Next, SelectedItem;
	local translator Translator;
	local int TempX,TempY, HalfHUDX, HalfHUDY, AmmoIconSize, i;

	if ( Owner.Inventory==None) Return;
	bGotSelected = False;
	bGotNext = false;
	bGotPrev = false;
	Prev = None;
	Next = None;
	SelectedItem = Pawn(Owner).SelectedItem;

	for ( Inv=Owner.Inventory; Inv!=None; Inv=Inv.Inventory )
	{
			if ( Inv == SelectedItem )
				bGotSelected = True;
			else if ( Inv.bActivatable )
			{
				if ( bGotSelected )
				{
					if ( !bGotNext )
					{
						Next = Inv;
						bGotNext = true;
					}
					else if ( !bGotPrev )
						Prev = Inv;
				}
				else
				{
					if ( Next == None )
						Next = Prev;
					Prev = Inv;
					bGotPrev = True;
				}
			}

		if ( Translator(Inv) != None )
			Translator = Translator(Inv);

		if ( (Inv.InventoryGroup>0) && (Weapon(Inv)!=None) && (Inv.InventoryGroup<11) )
		{
			Canvas.Font=font'TahomaB10';
			Canvas.DrawColor=GetC(255,255,255);
			if ((Weapon(Inv).AmmoType==None)||(Weapon(Inv).AmmoType.AmmoAmount==0))
			Canvas.DrawColor=GetC(255,0,0);
			//Draw that this gun is HERE
			Canvas.SetPos(Canvas.ClipX-HalfHudOffs[Inv.InventoryGroup]+14,Canvas.ClipY-400+Inv.InventoryGroup*23+1);
			if (Inv.InventoryGroup<10)
			Canvas.DrawText(Inv.InventoryGroup);
			else
			Canvas.DrawText("0");
		}
		Canvas.DrawColor=GetC(255,255,255);

		if ( (HudMode < 4) && (Ammo(Inv)!=None) )
		{
			for (i=0; i<10; i++)
			{
				if (Ammo(Inv).UsedInWeaponSlot[i]==1)
				{
					Canvas.SetPos(Canvas.ClipX-HalfHudOffs[Inv.InventoryGroup],Canvas.ClipY-400+Inv.InventoryGroup*23);

				}
			}
		}
	}

	// List Translator messages if activated
	if ( (Owner!=None) && (Owner.IsA('DPlayer')) )
	{
	if ( Translator!=None )
	{
		if( DPlayer(Owner).TranActiv )
		{
			Canvas.bCenter = false;
			//Canvas.Font = Canvas.MedFont;
			TempX = Canvas.ClipX;
			TempY = Canvas.ClipY;
			if (DPlayer(Owner).ThatsHint)
			CurrentMessage=DPlayer(Owner).TranHint;
			else
			CurrentMessage=DPlayer(Owner).TranMsg;
			// Temp //
			//if (DPlayer(Owner).ThatsHint)
			//	Canvas.DrawColor=GetC(255,255,0);
			//else
			//	Canvas.DrawColor=GetC(128,255,128);
			Canvas.Style = 3;
			Canvas.DrawColor=GetC(255,255,255,255);
			/* 512x512 is oversized '-_- have to split into pieces */

			//Canvas.SetPos(Canvas.ClipX/2-243+1,Canvas.ClipY/2-192);
			//Canvas.DrawTile(texture'Unreal2UI',485,19,0,4,485,19);
			Canvas.SetPos(Canvas.ClipX/2-243+1,Canvas.ClipY/2-192);
			Canvas.DrawTile(texture'U2TranStuff',256,19,0,0,256,19);
			Canvas.SetPos(Canvas.ClipX/2-243+1+256,Canvas.ClipY/2-192);
			Canvas.DrawTile(texture'U2TranStuff',229,19,0,20,229,19);

			//Canvas.SetPos(Canvas.ClipX/2-243+35,Canvas.ClipY/2-192+19);
			//Canvas.DrawTile(texture'Unreal2UI',394,8,106,497,394,8);
			Canvas.SetPos(Canvas.ClipX/2-243+35,Canvas.ClipY/2-192+19);
			Canvas.DrawTile(texture'U2TranStuff',256,8,0,104,256,8);
			Canvas.SetPos(Canvas.ClipX/2-243+35+256,Canvas.ClipY/2-192+19);
			Canvas.DrawTile(texture'U2TranStuff',138,8,0,113,138,8);

			//Canvas.SetPos(Canvas.ClipX/2-243-1,Canvas.ClipY/2+192-31);
			//Canvas.DrawTile(texture'Unreal2UI',487,31,22,26,487,31);
			Canvas.SetPos(Canvas.ClipX/2-243-1,Canvas.ClipY/2+192-31);
			Canvas.DrawTile(texture'U2TranStuff',256,31,0,40,256,31);
			Canvas.SetPos(Canvas.ClipX/2-243-1+256,Canvas.ClipY/2+192-31);
			Canvas.DrawTile(texture'U2TranStuff',231,31,0,72,231,31);
			Canvas.SetPos(Canvas.ClipX/2-243+140,Canvas.ClipY/2-192+11);

			/* At least those have higher quality (^^) */

			Canvas.Font=font'TahomaB10';
			if (DPlayer(Owner).ThatsHint)
				Canvas.DrawText("Translator Hint");
			else
				Canvas.DrawText("Translator Message");
			Canvas.SetPos(0,0);
			Canvas.SetOrigin(Canvas.ClipX/2-243+35,Canvas.ClipY/2-192+28);
			Canvas.SetClip(394,326);
			Canvas.DrawColor=GetC(128,128,128,128);
			//for (I=0;I<21;I++)
			//{
			//Canvas.SetPos(0,I*15);
			//Canvas.DrawTile(texture'Unreal2UI',394,15.1,94,449,114,15);
			//Canvas.DrawTile(texture'U2TranGrad',394,15.1,0,0,114,15);
			//}
			//Canvas.SetPos(0,315);
			//Canvas.DrawTile(texture'Unreal2UI',394,10,94,449,114,10);
			//Canvas.DrawTile(texture'U2TranGrad',394,10,0,0,114,10);
			Canvas.DrawColor=GetC(0,64,128);
			Canvas.SetPos(-35-24,0);
			//Canvas.DrawTile(texture'U2Grad',256,325,0,0,256,7);
			Canvas.DrawTile(texture'GradL',256,325,0,0,256,2);
			Canvas.SetPos(256-35-24,0);
			//Canvas.DrawTile(texture'U2Grad',256,325,0,9,256,7);
			Canvas.DrawTile(texture'GradR',256,325,0,0,256,2);
			Canvas.SetPos(4,4);
			Canvas.Style = 1;
			Canvas.Font=WhiteFont;
			Canvas.DrawColor=GetC(0,128,255);
			Canvas.DrawText(CurrentMessage, False);
			HUDSetup(canvas);
			Canvas.ClipX = TempX;
			Canvas.ClipY = TempY;
			Canvas.SetOrigin(0,0);
		}
		else
			bFlashTranslator = ( Translator.bNewMessage || Translator.bNotNewMessage );
	}
	}
	else if ( Translator!=None )
	{
	/* No mercy. No fancy translator. Fuck you idiot. */
		if( Translator.bCurrentlyActivated )
		{
			Canvas.bCenter = false;
			Canvas.Font = Canvas.MedFont;
			TempX = Canvas.ClipX;
			TempY = Canvas.ClipY;
			CurrentMessage = Translator.NewMessage;
			Canvas.Style = 2;
			Canvas.SetPos(Canvas.ClipX/2-128, Canvas.ClipY/2-68);
			Canvas.DrawIcon(texture'TranslatorHUD3', 1.0);
			Canvas.SetOrigin(Canvas.ClipX/2-110,Canvas.ClipY/2-52);
			Canvas.SetClip(225,110);
			Canvas.SetPos(0,0);
			Canvas.Style = 1;
			Canvas.DrawText(CurrentMessage, False);
			HUDSetup(canvas);
			Canvas.ClipX = TempX;
			Canvas.ClipY = TempY;
			Canvas.SetOrigin(0,0);
		}
		else
			bFlashTranslator = ( Translator.bNewMessage || Translator.bNotNewMessage );
	}

	if ( SelectedItem != None )
	{
		Count++;
		if (Count>20) Count=0;

		if (Prev!=None)
		{
			if ( Prev.bActive )
			{
				Canvas.DrawColor.b = 0;
				Canvas.DrawColor.g = 0;
			}
			if ( bFlashTranslator && (Translator == Prev) && (Count>15) )
			{
				if (Translator.bNewMessage)
					Canvas.DrawColor.b=0;
				if (Translator.bNotNewMessage)
					Canvas.DrawColor.g=0;
			}
			DrawHudIcon(Canvas, X, Y, Prev);
			if ( (Pickup(Prev) != None) && Pickup(Prev).bCanHaveMultipleCopies )
				DrawNumberOf(Canvas,Pickup(Prev).NumCopies,X,Y);
			Canvas.DrawColor.b = 255;
			Canvas.DrawColor.g = 255;
		}
		if ( SelectedItem.Icon != None )
		{
			if ( SelectedItem.bActive )
			{
				Canvas.DrawColor.b = 0;
				Canvas.DrawColor.g = 0;
			}
			if ( bFlashTranslator && (Translator == SelectedItem) && (Count>15) )
			{
				if (Translator.bNewMessage)
					Canvas.DrawColor.b=0;
				if (Translator.bNotNewMessage)
					Canvas.DrawColor.g=0;
			}
			if ( (Next==None) && (Prev==None) && !bDrawOne) DrawHudIcon(Canvas, X+64, Y, SelectedItem);
			else DrawHudIcon(Canvas, X+32, Y, SelectedItem);
			Canvas.Style = 2;
			Canvas.CurX = X+32;
			if ( (Next==None) && (Prev==None) && !bDrawOne ) Canvas.CurX = X+64;
			Canvas.CurY = Y;
			Canvas.DrawIcon(texture'IconSelection', 1.0);
			if ( (Pickup(SelectedItem) != None)
				&& Pickup(SelectedItem).bCanHaveMultipleCopies )
				DrawNumberOf(Canvas,Pickup(SelectedItem).NumCopies,Canvas.CurX-32,Y);
			Canvas.Style = 1;
			Canvas.DrawColor.b = 255;
			Canvas.DrawColor.g = 255;
		}
		if (Next!=None) {
			if ( Next.bActive )
			{
				Canvas.DrawColor.b = 0;
				Canvas.DrawColor.g = 0;
			}
			if ( bFlashTranslator && (Translator == Next) && (Count>15) )
			{
				if (Translator.bNewMessage)
					Canvas.DrawColor.b=0;
				if (Translator.bNotNewMessage)
					Canvas.DrawColor.g=0;
			}
			DrawHudIcon(Canvas, X+64, Y, Next);
			if ( (Pickup(Next) != None) && Pickup(Next).bCanHaveMultipleCopies )
				DrawNumberOf(Canvas,Pickup(Next).NumCopies,Canvas.CurX-32,Y);
			Canvas.DrawColor.b = 255;
			Canvas.DrawColor.g = 255;
		}
	}
}

function DrawHudIcon2(Canvas Canvas, int X, int Y, Inventory Item)
{
	Local int Width;
	if (Item.Icon==None) Return;
	Width = Canvas.CurX;
	Canvas.CurX = X;
	Canvas.CurY = Y;
	Canvas.DrawIcon(Item.Icon, 1.0);
	Canvas.CurX -= 30;
	Canvas.CurY += 28;
//	if ((HudMode!=2 && HudMode!=4 && HudMode!=1) || !Item.bIsAnArmor)
//		Canvas.DrawTile(Texture'HudLine',fMin(27.0,27.0*(float(Item.Charge)/float(Item.Default.Charge))),2.0,0,0,32.0,2.0);
	Canvas.CurX = Width + 32;
}

function DrawArmor2(Canvas Canvas, int X, int Y)
{
	Local int ArmorAmount;
	local inventory Inv;
	Local float XL, YL;

	ArmorAmount = 0;
	ArmorOffset = 0;
	Canvas.Font = Canvas.LargeFont;
	Canvas.CurX = X;
	Canvas.CurY = Y;
	for( Inv=Owner.Inventory; Inv!=None; Inv=Inv.Inventory )
	{
		if (Inv.bIsAnArmor)
		{
			ArmorAmount += Inv.Charge;
			if (Inv.Charge>0 && Inv.Icon!=None)
			{
					ArmorOffset += 32;
					DrawHudIcon2(Canvas, Canvas.CurX, Y, Inv);
					DrawIconValue(Canvas, Inv.Charge);
			}
		}
	}
	Canvas.CurY = Y;
	if (ArmorAmount>0)
	{
		Canvas.StrLen(ArmorAmount,XL,YL);
		ArmorOffset += XL;
		Canvas.DrawText(ArmorAmount,False);
	}
}

function DrawIconValue(Canvas Canvas, int Amount)
{
	local int TempX,TempY;

	if (HudMode==3) Return;

	TempX = Canvas.CurX;
	TempY = Canvas.CurY;
	Canvas.CurX -= 20;
	Canvas.CurY -= 5;
	if (Amount<100) Canvas.CurX+=6;
	if (Amount<10) Canvas.CurX+=6;
	Canvas.Font = Font'TinyFont';
	Canvas.DrawText(Amount,False);
	Canvas.Font = Canvas.LargeFont;
	Canvas.CurX = TempX;
	Canvas.CurY = TempY;
}

defaultproperties
{
				WhiteFont=Font'DCoopTextures.UWindowFonts.UTFont12'
}
